<?php
/*
 * @desc 北大医信HIS模拟类
 * @author wangxinghua
 * @final 2020-08-03
 */
class Bdyx
{
	//统一错误处理
	public function error_xml($msg)
	{
		return '<?xml version="1.0" encoding="utf8"?><root><result><info execute_flag="-1" execute_message="'.$msg.'"/></result></root>';
	}
	//网关方法
	public function founderRequestData($in)
	{
		$in = json_decode($in, true);
		$field = array('userName','password','businessType','requestData');
		foreach ($field as $v)
		{
			if(!isset($in[$v]))
			{
				return $this->error_xml('参数'.$v.'必须传');
			}
			if($in[$v] == '')
			{
				return $this->error_xml('参数'.$v.'不能为空');
			}
		}
		if($in['userName'] != '10002')
		{
			return $this->error_xml('参数userName不正确');
		}
		if($in['password'] != '123456')
		{
			return $this->error_xml('参数password不正确');
		}
		$function = $in['businessType'];
		if(method_exists($this, $function))
			return $this->$function($in['requestData']);
		else
			return $this->error_xml('找不到'.$in['requestData'].'业务方法');
	}
	//出诊科室
	public function YYT_QRY_CLINIC_DEPT($in)
	{
		$out = '<?xml version="1.0" encoding="gb2312"?>
<root><commitdata><data><datarow start_date="20200723" end_date="20200723" gh_flag="1" class_code="%"/></data></commitdata><returndata><data><datarow class_code="0301" class_name="呼吸内科专业"><item unit_sn="4010701" unit_name="呼吸科一区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0302" class_name="消化内科专业"><item unit_sn="4010501" unit_name="脾胃病科一区门诊" dept_position="" yb_limit="0"/><item unit_sn="4010504" unit_name="肝胆胰中医特色门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0303" class_name="神经内科专业"><item unit_sn="4010609" unit_name="脑病科一区门诊" dept_position="" yb_limit="0"/><item unit_sn="4010610" unit_name="脑病科二区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0304" class_name="心血管内科专业"><item unit_sn="4010201" unit_name="心血管科一区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0305" class_name="血液内科专业"><item unit_sn="4010801" unit_name="血液、肿瘤科门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0306" class_name="肾病学专业"><item unit_sn="4010406" unit_name="肾病内分泌科一区门诊" dept_position="" yb_limit="0"/><item unit_sn="4010407" unit_name="肾病内分泌科二区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0307" class_name="内分泌专业"><item unit_sn="4021100" unit_name="甲状腺病科门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0310" class_name="老年病专业"><item unit_sn="4010901" unit_name="脑病科三区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0311" class_name="其他内科"><item unit_sn="4010301" unit_name="普通内科(内二科）" dept_position="" yb_limit="0"/></datarow><datarow class_code="0401" class_name="普通外科专业"><item unit_sn="4020901" unit_name="普外科一区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0403" class_name="骨科专业"><item unit_sn="4060001" unit_name="骨伤科门诊" dept_position="" yb_limit="0"/><item unit_sn="4060009" unit_name="骨伤科三区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0404" class_name="泌尿外科专业"><item unit_sn="4020301" unit_name="泌尿外科门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0409" class_name="其他外科"><item unit_sn="4020201" unit_name="周围血管科门诊" dept_position="" yb_limit="0"/><item unit_sn="4020801" unit_name="乳腺科门诊" dept_position="" yb_limit="0"/><item unit_sn="4020903" unit_name="男科门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="0501" class_name="妇科专业"><item unit_sn="4040001" unit_name="妇科一区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="10" class_name="眼科"><item unit_sn="4090001" unit_name="眼科一区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="11" class_name="耳鼻咽喉科"><item unit_sn="4100001" unit_name="耳鼻喉科门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="1201" class_name="口腔科专业"><item unit_sn="4080009" unit_name="口腔治疗" dept_position="" yb_limit="0"/></datarow><datarow class_code="1204" class_name="口腔修复专业"><item unit_sn="4080006" unit_name="口腔镶牙" dept_position="" yb_limit="0"/></datarow><datarow class_code="1301" class_name="皮肤专业"><item unit_sn="4110001" unit_name="皮肤科门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="26" class_name="麻醉科"><item unit_sn="4030000" unit_name="麻醉科" dept_position="" yb_limit="0"/><item unit_sn="4030003" unit_name="麻醉科评估门诊" dept_position="" yb_limit="0"/><item unit_sn="4030004" unit_name="麻醉科疼痛门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="32" class_name="医学影像科"><item unit_sn="5010000" unit_name="放射科" dept_position="" yb_limit="0"/></datarow><datarow class_code="3204" class_name="核医学专业"><item unit_sn="5060000" unit_name="核医学科" dept_position="" yb_limit="0"/></datarow><datarow class_code="3205" class_name="超声诊断专业"><item unit_sn="5030002" unit_name="B超室" dept_position="" yb_limit="0"/></datarow><datarow class_code="3209" class_name="介入放射学专业"><item unit_sn="4010503" unit_name="胃镜室" dept_position="" yb_limit="0"/></datarow><datarow class_code="5011" class_name="肛肠科专业"><item unit_sn="4020401" unit_name="肛肠科一区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="5013" class_name="针灸科专业"><item unit_sn="4120001" unit_name="针灸科一区门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="5014" class_name="推拿科专业"><item unit_sn="4070001" unit_name="推拿科门诊" dept_position="" yb_limit="0"/><item unit_sn="4070005" unit_name="推拿疼痛门诊" dept_position="" yb_limit="0"/></datarow><datarow class_code="5015" class_name="康复医学专业"><item unit_sn="4150000" unit_name="康复科" dept_position="" yb_limit="0"/></datarow><datarow class_code="5018" class_name="其他中医科"><item unit_sn="G401302" unit_name="国际部综合门诊" dept_position="" yb_limit="0"/></datarow></data></returndata><operateinfo><info method="YYT_QRY_CLINIC_DEPT" opt_id="zzj_test" opt_name="zzj_test" opt_ip="172.17.5.3" opt_date="2020-07-23" guid="1595478577200" token="AUTO-YYRMYY-20200723"/></operateinfo><result><info execute_flag="0" execute_message="执行成功" account="2020-07-23 12:28:39"/></result></root>';
		return $out;
	}
	//挂号划价
	public function YYT_GH_CALC($in)
	{
		$Out = '<?xml version="1.0" encoding="gb2312"?>
<root><commitdata><data><datarow record_sn="505879" patient_id="000000012300" card_code="06" card_no="131022198803185913" req_type="" gh_flag="2"/></data></commitdata><returndata><data><datarow patient_id="000000012300" charge_total="50" cash="50" zhzf="0" tczf="0" pay_seq="505879_2"/></data></returndata><operateinfo><info method="YYT_GH_CALC" opt_id="zzj_test" opt_name="zzj_test" opt_ip="172.17.5.3" opt_date="2020-07-23" guid="1595487385634" token="AUTO-YYRMYY-2020-07-23"/></operateinfo><result><info execute_flag="0" execute_message="挂号划价成功!" account="2020-07-23 14:55:30"/></result></root>';
		return $out;
	}
	//挂号成功
	public function YYT_GH_SAVE($in)
	{
		$Out = '<?xml version="1.0" encoding="gb2312"?>
<root><commitdata><data><datarow record_sn="505879" pay_seq="505879_2" responce_type="03" patient_id="000000012300" card_code="06" card_no="131022198803185913" charge_total="50" cash="50" zhzf="0" tczf="0" record_id="" gh_sequence="" bk_card_no="" trade_no="4200000575202007239922778501" stream_no="hos057wxpay20200723145630696549" addition_no1="" trade_time="2020-07-23" cheque_type="w" gh_flag="2" bank_type="" req_type="06" times="3068"/></data></commitdata><returndata><data row_count="1"><datarow patient_id="000000012300" times="3068" flag="1" patient_name="测试" sex="男" age="32岁" unit_name="门诊办" group_name="" emp_name="" clinic_name="新冠核酸检测号" req_name="网站预约" req_date="2020-07-23" response_type="自费医疗" enter_opera="zzj02" enter_date="2020-07-23T14:55:55" cheque_type="微信" gh_date="2020-07-23" sequence_no="2" ampm="下午" receipt_sn="19954869" total_fee="50.00" fee_yb="0.00" fee_zf="50.00" fee_df="0.00" fee_zhzf="0.00" outpatient_no="123456" suggest_time="13:00 - 16:30" visit_dept="2070100" req_type="06" location_info="门诊办(平房)" fz=""/></data></returndata><operateinfo><info method="YYT_GH_SAVE" opt_id="zzj02" opt_name="zzj02" opt_ip="172.17.5.3" opt_date="2020-07-23" guid="hos057wxpay20200723145630696549" token="AUTO-YYRMYY-2020-07-23"/></operateinfo><result><info execute_flag="0" execute_message="执行成功" account="2020-07-23 14:55:58"/></result></root>';
		return $out;
	}
	public function test($params)
	{
		$field = array('userName','password','businessType','requestData');
		foreach ($field as $k => $v)
		{
			if(!isset($k) && $v == '')
			{
				return $this->error_xml('参数'.$k.'不能为空');
			}
		}
		if($params->userName != '10002')
		{
			return $this->error_xml('参数userName不正确');
		}
		if($params->password != '123456')
		{
			return $this->error_xml('参数password不正确');
		}
		$function = $params->businessType;
		if(method_exists($this, $function))
			return $this->$function($params->requestData);
		else
			return $this->error_xml('找不到'.$params->requestData.'业务方法');
	}
}